//Test for substituting href for multiple links html file.
import  java.io.*;
import  java.util.*;
import  org.w3c.dom.*;
import  org.w3c.dom.html.*;
import  org.w3c.dom.html.HTMLElement.*;
import  org.openxml.*;
import  org.openxml.io.*;
import  org.openxml.x3p.*;
import  org.openxml.util.*;
import  org.openxml.parser.*;

class TestParser5 {
    //static int tab;
    
    public static void main (String args[]) throws IOException {
        Parser parser;
        InputStream is;
        Document doc;
        Publisher pub;
                       
        is = new FileInputStream("area.html");
        parser = DOMFactory.createParser( is, null, null );
        doc = parser.parseDocument();
        
        System.out.println("A Parser is constructed.\n");
        //System.out.println("URL: " + doc.getURL() + "\n");
        //System.out.println(doc.getDocumentElement().getFirstChild().getNodeName() + "\n");
        //System.out.println(doc.getDocumentElement().getFirstChild().getNodeValue() + "\n");
        
        //tab = 0;
        substituteHref( doc );
        
        pub = PublisherFactory.createPublisher( new File("output.html"), StreamFormat.HTML );
        pub.publish( doc );
        pub.close();      
   
        listHref (doc);
    }
    
    static void substituteHref( Node node ) {
        while ( node != null ) {
            //for (int i=0; i< tab; i++)
            //    System.out.print("    ");
            System.out.println( "Node name [" + node.getNodeName() + "] value [" +
                                node.getNodeValue() + "]" );
            if ( node.getNodeName().toUpperCase().compareTo("A") == 0 || node.getNodeName().toUpperCase().compareTo("AREA") == 0 ) {
                NamedNodeMap map = node.getAttributes();
                if ( map != null ) {
                    int length = map.getLength();
                    if ( length > 0 ) {
                        for (int i = 0; i < length; i++) {
                            String attrbname = map.item(i).getNodeName().toUpperCase();
                            String attrbvalue = map.item(i).getNodeValue();
                            System.out.println( "***" + attrbname + " " + attrbvalue );
                            if ( attrbname.compareTo("HREF") == 0 ) {
                                Node aclonenode = node.cloneNode(true);
                                Node attrbclone = map.item(i).cloneNode(true);
                                attrbclone.setNodeValue("http://www.npac.syr.edu/" + attrbvalue);
                                aclonenode.getAttributes().setNamedItem(attrbclone);
                                System.out.println(aclonenode.getAttributes().item(i).getNodeValue());
                                node.getParentNode().replaceChild(aclonenode, node);
                                node = aclonenode;
                            }
                        }
                    }
                }
                else {
                    //System.out.println( "Null" );
                }
            } 
            //if ( node.getNodeName().compareTo("#text") == 0 )
            //    --tab;
            if ( node.hasChildNodes() ) {
                //System.out.print( "-C-" );
                //tab++;
                substituteHref ( node.getFirstChild() );
            }
            //System.out.print("-S-");
            node = node.getNextSibling();
        }
        //System.out.print("-E-");
        //tab--;
    }

    static void listHref ( Node node ) {
        while ( node != null ) {
            NamedNodeMap map = node.getAttributes();
            if ( map != null ) {
                int length = map.getLength();
                if ( length > 0 ) {
                    String attrbname = map.item(0).getNodeName().toUpperCase();
                    String attrbvalue = map.item(0).getNodeValue();
                    if ( attrbname.compareTo("HREF") == 0 ) {
                        System.out.println("{HREF}" + attrbvalue);
                    }
                }
            }
            System.out.print( "[" + node.getNodeName() + "]" +
                              node.getNodeValue() );
            if ( node.hasChildNodes() ) {
                listHref ( node.getFirstChild() );
            }
            node = node.getNextSibling();
        }
    }
     
}
