//Test for filtering Javascript part from an Html input file.
import  java.io.*;
import  java.util.*;
import  org.w3c.dom.*;
import  org.w3c.dom.html.*;
import  org.w3c.dom.html.HTMLElement.*;
import  org.openxml.*;
import  org.openxml.io.*;
import  org.openxml.x3p.*;
import  org.openxml.util.*;
import  org.openxml.parser.*;

class TestParser6 {
    //static int tab;
    
    public static void main (String args[]) throws IOException {
        Parser parser;
        InputStream is;
        Document doc;
        Publisher pub;
                       
        is = new FileInputStream("parser.html");
        parser = DOMFactory.createParser( is, null, null );
        doc = parser.parseDocument();
        
        System.out.println("A Parser is constructed.\n");
        //System.out.println("URL: " + doc.getURL() + "\n");
        //System.out.println(doc.getDocumentElement().getFirstChild().getNodeName() + "\n");
        //System.out.println(doc.getDocumentElement().getFirstChild().getNodeValue() + "\n");
        
        //tab = 0;
        substituteHref( doc );
       
        pub = PublisherFactory.createPublisher( new File("output.html"), StreamFormat.HTML );
        pub.publish( doc );
        pub.close();      
   
    }

    public String processJS( String page )
    {
	int start = page.toUpperCase().indexOf("<SCRIPT");
	if ( start < 0 ) {
	    if ( page.indexOf("< ") > 0 )
		return "Improved filter needed.";
	    else
		return page;
	}
	else {
	    int end = page.toUpperCase().indexOf("</SCRIPT");
	    int last = page.indexOf('>', end);
	    if ( end < last ) {
		String firstpage = page.substring(0, start-1);
		String restpage = page.substring(last+1);
		if ( restpage.toUpperCase().indexOf("<SCRIPT") < 0 )
		    return firstpage + restpage;
		else
		    return firstpage + processJS( restpage );
	    }
	    else {
		return "Script Error!";
	    }
	}
    }

    static void substituteHref ( Node node ) {
        while ( node != null ) {
	    if ( node.getNodeName().toUpperCase().compareTo("A") == 0 ||
		 node.getNodeName().toUpperCase().compareTo("AREA") == 0 ) {
		NamedNodeMap map = node.getAttributes();
            	if ( map != null ) {
                    int length = map.getLength();
                    System.out.println("Length: " + length);
                    for (int i=0; i < length; i++) {
                        System.out.println("i: " + i );
                    	String attrbname = map.item(i).getNodeName().toUpperCase();
                    	String attrbvalue = map.item(i).getNodeValue();
                        if ( attrbname.compareTo("HREF") == 0 ) {
			    Node aclonenode = node.cloneNode(true);
			    Node attrbclone = map.item(i).cloneNode(true);
			    attrbclone.setNodeValue("http://arkansas/example/Enhancer?url=" + attrbvalue);
			    aclonenode.getAttributes().setNamedItem(attrbclone);
			    node.getParentNode().replaceChild(aclonenode, node);
			    node = aclonenode;
                            //System.out.println("{HREF}" + attrbvalue);
                    	}
		    }
                }
            }
            if ( node.hasChildNodes() ) {
                substituteHref ( node.getFirstChild() );
            }
            node = node.getNextSibling();
        }
    }
     
}
