import java.lang.*;
import java.util.StringTokenizer;

class Test {
  public static void main (String args[]) {
    String test = "<HTML>" +
		  "<HEAD>" +
		  "<TITLE>Hello</TITLE>" +
		  "</HEAD>" +
		  "<BODY>" +
		  "Hello World" +
                  "<A HREF=\"http://www.apache.org/\">Apache</A>" +
                  "</BODY></HTML>";
    TagSplitter htmls = new TagSplitter(test);
    StringTokenizer first = new StringTokenizer(htmls.GetItem(5));
    System.out.println("Sixth Item: " + first.nextToken());
    String aContent = htmls.GetItemOfType("BODY", 0);
    System.out.println("BODY's content: " + aContent);
    aContent = htmls.GetItemOfType("A", 0);
    System.out.println("Anchor's content: " + aContent);
  }
}

class TagSplitter {

    private String source;
    private int number;
    private String Tag[];
    private String TagType[];
    private String Content[];

    TagSplitter(String source) {
	this.source = source;
	StringTokenizer tokenizer = new StringTokenizer(source, "<");
	this.number = tokenizer.countTokens();
	Tag = new String[number];
        TagType = new String[number];
	Content = new String[number];

	for (int i=0; i < number; i++) {
	    String aToken = tokenizer.nextToken();
	    StringTokenizer aTokenizer = new StringTokenizer(aToken, ">");
	    Tag[i] = aTokenizer.nextToken();

	    int end = Tag[i].indexOf(32);
            if (end > 0) {
                TagType[i] = Tag[i].substring(0, end);
            }
            else {
                TagType[i] = Tag[i];
            }

	    if (aTokenizer.hasMoreTokens()) {
		Content[i] = aTokenizer.nextToken();
	    }
	    else {
		Content[i] = "";
	    }
	}
    }

    int GetCount() {
	return number;
    }

    String GetItem(int index) {
	if (index < number) {
	    return Content[index];
	}
	else {
	    return "";
	}
    }

    String GetItemOfType(String type, int index) {
	int n = 0;

	for (int i=0; i < number; i++) {
	    if (type.compareTo(TagType[i]) == 0) {
		if (index == n) {
		    return Content[i];
		}
		else {
		    n++;
		}
	    }
	}
	return "";
    }
}
