import java.lang.*;
import java.util.StringTokenizer;

class Test {
  public static void main (String args[]) {
    String test = "<HTML>" +
		  "<HEAD>" +
		  "<TITLE>Hello</TITLE>" +
		  "</HEAD>" +
		  "<BODY>" +
		  "Hello World" +
                  "<A HREF=\"http://www.apache.org/\">Apache</A>" +
                  "</BODY></HTML>";
    TapSplitter htmls = new TapSplitter(test);
    StringTokenizer first = new StringTokenizer(htmls.GetItem(5));
    System.out.println("Sixth Item: " + first.nextToken());
    String aContent = htmls.GetItemedType("BODY", 0);
    System.out.println("BODY's content: " + aContent);
    aContent = htmls.GetItemedType("A", 0);
    System.out.println("Anchor's content: " + aContent);
  }
}

class TapSplitter {
  String source;
  int number;
  String Tag[];
  String Content[];

  TapSplitter(String source) {
    this.source = source;
    StringTokenizer tokenizer = new StringTokenizer(source, "<");
    this.number = tokenizer.countTokens();
    Tag = new String[number];
    Content = new String[number];
    for (int i=0; i < number; i++) {
      String aToken = tokenizer.nextToken();
      StringTokenizer aTokenizer = new StringTokenizer(aToken, ">");
      Tag[i] = aTokenizer.nextToken();
      if (aTokenizer.hasMoreTokens()) {
        Content[i] = aTokenizer.nextToken();
      }
      else {
        Content[i] = "";
      }
    }
  }

  int GetCount() {
    return number;
  }

  String GetItem(int index) {
    if (index < number) {
      return Content[index];
    }
    else {
      return "";
    }
  }

  String GetItemedType(String type, int index) {
    int n = 0;
    String aTag = "";

    for (int i=0; i < number; i++) {
      int end = Tag[i].indexOf(32);
      if (end > 0) {
        aTag = Tag[i].substring(0, end);
      }
      else {
        aTag = Tag[i];
      }
      if (type.compareTo(aTag) == 0) {
        if (index == n) {
          return Content[i];
        }
        else {
          n++;
        }
      }
    }
    return "";
  }
}
